import type { Container } from "./Container";
import type { IContainerPlugin } from "./Interfaces/IContainerPlugin";
import type { IDelta } from "./Interfaces/IDelta";
import type { IDimension } from "./Interfaces/IDimension";
import type { Particle } from "./Particle";
export declare class Canvas {
    private readonly container;
    element?: HTMLCanvasElement;
    resizeFactor?: IDimension;
    readonly size: IDimension;
    private _colorPlugins;
    private _context;
    private _coverColorStyle?;
    private _generated;
    private readonly _mutationObserver?;
    private _originalStyle?;
    private _postDrawUpdaters;
    private _preDrawUpdaters;
    private _resizePlugins;
    private _trailFill?;
    constructor(container: Container);
    private get _fullScreen();
    clear(): void;
    destroy(): void;
    draw<T>(cb: (context: CanvasRenderingContext2D) => T): T | undefined;
    drawParticle(particle: Particle, delta: IDelta): void;
    drawParticlePlugin(plugin: IContainerPlugin, particle: Particle, delta: IDelta): void;
    drawPlugin(plugin: IContainerPlugin, delta: IDelta): void;
    init(): Promise<void>;
    initBackground(): void;
    initPlugins(): void;
    initUpdaters(): void;
    loadCanvas(canvas: HTMLCanvasElement): void;
    paint(): void;
    resize(): void;
    stop(): void;
    windowResize(): Promise<void>;
    private _applyPostDrawUpdaters;
    private _applyPreDrawUpdaters;
    private _applyResizePlugins;
    private _getPluginParticleColors;
    private _initCover;
    private _initStyle;
    private _initTrail;
    private _paintBase;
    private _paintImage;
    private _repairStyle;
    private _resetOriginalStyle;
    private _setFullScreenStyle;
}
