(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Modes = void 0;
    class Modes {
        constructor(engine, container) {
            this._engine = engine;
            this._container = container;
        }
        load(data) {
            if (!data) {
                return;
            }
            if (this._container) {
                const interactors = this._engine.plugins.interactors.get(this._container);
                if (interactors) {
                    for (const interactor of interactors) {
                        if (interactor.loadModeOptions) {
                            interactor.loadModeOptions(this, data);
                        }
                    }
                }
            }
        }
    }
    exports.Modes = Modes;
});
